unit uMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, uPSDBTreeView.Main, uniGUIBaseClasses, uniGUIClasses, uniPanel,
  Vcl.StdCtrls, Vcl.Buttons,uCoffeetest.DB.Connection, Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    UniPanel1: TUniPanel;
    UniPanel2: TUniPanel;
    bInitialUpdate: TBitBtn;
    bInitialUpdate2: TBitBtn;
    bAddFolder: TBitBtn;
    bAddFile: TBitBtn;
    bUp: TBitBtn;
    bDown: TBitBtn;
    bCopy: TBitBtn;
    bCut: TBitBtn;
    bPaste: TBitBtn;
    bDelete2: TBitBtn;
    bDown2: TBitBtn;
    bUp2: TBitBtn;
    bCopy2: TBitBtn;
    bTest: TBitBtn;
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    UniPanel3: TUniPanel;
    bInitialUpdate3: TBitBtn;
    bAddFolder3: TBitBtn;
    bAddFile3: TBitBtn;
    bUp3: TBitBtn;
    bDown3: TBitBtn;
    bCopy3: TBitBtn;
    bCut3: TBitBtn;
    bPaste3: TBitBtn;
    bDelete3: TBitBtn;
    PSDBTreeView2: TPSDBTreeView;
    PSDBTreeView1: TPSDBTreeView;
    procedure bInitialUpdateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bDeleteClick(Sender: TObject);
    procedure bAddFolderClick(Sender: TObject);
    procedure bAddFileClick(Sender: TObject);
    procedure bUpClick(Sender: TObject);
    procedure bDownClick(Sender: TObject);
    procedure bCopyClick(Sender: TObject);
    procedure bCutClick(Sender: TObject);
    procedure bPasteClick(Sender: TObject);
    procedure bInitialUpdate2Click(Sender: TObject);
    procedure bAddFolder2Click(Sender: TObject);
    procedure bAddFile2Click(Sender: TObject);
    procedure bDelete2Click(Sender: TObject);
    procedure bDown2Click(Sender: TObject);
    procedure bUp2Click(Sender: TObject);
    procedure bCopy2Click(Sender: TObject);
    procedure bCut2Click(Sender: TObject);
    procedure bPaste2Click(Sender: TObject);
    procedure bTestClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bInitialUpdate3Click(Sender: TObject);
    procedure bAddFolder3Click(Sender: TObject);
    procedure bAddFile3Click(Sender: TObject);
    procedure bDelete3Click(Sender: TObject);
    procedure bDown3Click(Sender: TObject);
    procedure bUp3Click(Sender: TObject);
    procedure bCopy3Click(Sender: TObject);
    procedure bCut3Click(Sender: TObject);
    procedure bPaste3Click(Sender: TObject);
    procedure PageControlChange(Sender: TObject);
  private
    { Private declarations }

    DBConnection:TCoffeetestDBConnection;

    FidSelectedArray:TArray<integer>;
    FCurrentDBTreeView:TPSDBTreeView;
    FDeleteAfterCut:boolean;
    FtreeView:TTreeView;

    procedure OnFocusDBTreeView(Sender:TObject);

  public
    { Public declarations }

    {
    TOnExternalInsertSelect=procedure (AIDListInserted:Tarray<integer>  ) of object;

TOnCopyCut=procedure (AIDSelectedArray:Tarray<integer>  ) of object;
    }

   procedure OnCopyCut(AIDSelectedArray:Tarray<integer> );
   procedure OnExternalInsertSelect(AIDListInserted:Tarray<integer>);


  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bAddFile2Click(Sender: TObject);
begin
PSDBTreeView2.MC.AddFile('SomeFile2');
end;

procedure TForm1.bAddFile3Click(Sender: TObject);
begin
if Assigned(FCurrentDBTreeView) then
FCurrentDBTreeView.AddFile('SomeFile3');
end;

procedure TForm1.bAddFileClick(Sender: TObject);
begin
PSDBTreeView1.MC.AddFile('SomeFile');
end;

procedure TForm1.bAddFolder2Click(Sender: TObject);
begin
PSDBTreeView2.MC.AddFolder('SomeFolder2');
end;

procedure TForm1.bAddFolder3Click(Sender: TObject);
begin
if Assigned(FCurrentDBTreeView) then
FCurrentDBTreeView.AddFolder('SomeFolder3');
end;

procedure TForm1.bAddFolderClick(Sender: TObject);
begin
PSDBTreeView1.MC.AddFolder('SomeFolder');
end;

procedure TForm1.bCopy2Click(Sender: TObject);
begin
PSDBTreeView2.MC.Copy;
end;

procedure TForm1.bCopy3Click(Sender: TObject);
begin
if Assigned(FCurrentDBTreeView) then
FCurrentDBTreeView.Copy;
end;

procedure TForm1.bCopyClick(Sender: TObject);
begin
PSDBTreeView1.MC.Copy;
end;

procedure TForm1.bCut2Click(Sender: TObject);
begin
PSDBTreeView2.MC.Cut;
end;

procedure TForm1.bCut3Click(Sender: TObject);
begin
if Assigned(FCurrentDBTreeView) then
  begin
  FCurrentDBTreeView.Cut;
  FDeleteAfterCut:=FCurrentDBTreeView.MC.CopyCutPaste.DeleteAfterCut;
  FTreeView:=FCurrentDBTreeView.MC.MF.TreeView;
  end;

end;

procedure TForm1.bCutClick(Sender: TObject);
begin
PSDBTreeView1.MC.Cut;
end;

procedure TForm1.bDelete2Click(Sender: TObject);
begin
PSDBTreeView2.MC.DeleteCheckedOrSelected;
end;

procedure TForm1.bDelete3Click(Sender: TObject);
begin
if Assigned(FCurrentDBTreeView) then
FCurrentDBTreeView.DeleteCheckedOrSelected;
end;

procedure TForm1.bDeleteClick(Sender: TObject);
begin
PSDBTreeView1.MC.DeleteCheckedOrSelected;
end;

procedure TForm1.bDown2Click(Sender: TObject);
begin
PSDBTreeView2.MC.NodeDown;
end;

procedure TForm1.bDown3Click(Sender: TObject);
begin
if Assigned(FCurrentDBTreeView) then
FCurrentDBTreeView.NodeDown;
end;

procedure TForm1.bDownClick(Sender: TObject);
begin
PSDBTreeView1.MC.NodeDown;
end;

procedure TForm1.bInitialUpdate2Click(Sender: TObject);
begin
PSDBTreeView2.MC.InitialUpdate;
end;

procedure TForm1.bInitialUpdateClick(Sender: TObject);
begin
PSDBTreeView1.MC.InitialUpdate;
//(Sender as TPSDBTreeView).
end;


procedure TForm1.bInitialUpdate3Click(Sender: TObject);
begin
if Assigned(FCurrentDBTreeView) then FCurrentDBTreeView.InitialUpdate;
end;

procedure TForm1.bPaste2Click(Sender: TObject);
begin
//PSDBTreeView2.MC.Paste;

  PSDBTreeView2.mc.GetSelectedElements.IDSelectedArray:=FidSelectedArray;
  PSDBTreeView2.MC.Paste;

end;

procedure TForm1.bPaste3Click(Sender: TObject);
begin
if Assigned(FCurrentDBTreeView) then

begin
FCurrentDBTreeView.mc.GetSelectedElements.IDSelectedArray:=
FidSelectedArray;
FCurrentDBTreeView.MC.CopyCutPaste.deleteAfterCut:=FDeleteAfterCut;
FCurrentDBTreeView.MC.CopyCutPaste.TreeView:=FTreeView;
FCurrentDBTreeView.Paste;
end;

end;

procedure TForm1.bPasteClick(Sender: TObject);
begin
  PSDBTreeView1.mc.GetSelectedElements.IDSelectedArray:=FidSelectedArray;
  PSDBTreeView1.MC.Paste;
end;

procedure TForm1.bTestClick(Sender: TObject);
var i:integer;
    idSelectedArray:TArray<integer>;
begin

FCurrentDBTreeView.Rename('SomeNewName');
//idSelectedArray2:=PSDBTreeView2.MC.GetSelectedElements.IDSelectedArray;
{
  SetLength(idSelectedArray,0);
  for i := 0 to High(PSDBTreeView1.mc.GetSelectedElements.IDSelectedArray) do begin
      SetLength(idSelectedArray,Length(idSelectedArray)+1);
      idSelectedArray[i]:=PSDBTreeView1.mc.GetSelectedElements.IDSelectedArray[i];
  end;
}

//  PSDBTreeView2.mc.GetSelectedElements.IDSelectedArray:=FidSelectedArray;

  // insert Select

//  PSDBTreeView2.MC.Paste;


end;

procedure TForm1.bUp2Click(Sender: TObject);
begin
PSDBTreeView2.MC.NodeUp;
end;

procedure TForm1.bUp3Click(Sender: TObject);
begin
if Assigned(FCurrentDBTreeView) then
FCurrentDBTreeView.NodeUp;
end;

procedure TForm1.bUpClick(Sender: TObject);
begin
PSDBTreeView1.MC.NodeUp;
end;



procedure TForm1.FormCreate(Sender: TObject);
begin

ReportMemoryLeaksOnShutdown:=true;

DBConnection:=TCoffeetestDBConnection.Create(Self);
DBConnection.MyConnect;


PageControl.ActivePageIndex:=0;
FCurrentDBTreeView:=PSDBTreeView1;

{ doesn't copy paste if setup like this, OnCopyCut doesn't work
with PSDBTreeView1 do begin

   FDConnection:=DBConnection.FDConnection;

   DBName:='coffeetest_db';
   DBTable:='dbtreeexplorertesttable';

    id_field:='id';
    idParent_field:='idParent';
    name_field:='name';
    sortIndex_field:='sortIndex';
    isFolder_field:='isFolder';
    isTrash_field:='isTrash';
    isChecked_field:='isChecked';
    external_id_field:='external_id';


   IsUseExternalID:=true;
   external_id_value:=1;

    PSDBTreeView1.MC.CopyCutPaste.OnCopyCut:=OnCopyCut;
   PSDBTreeView1.MC.MF.OnFocus:=OnFocusDBTreeView;

   InitialSetup;
end;
}


with PSDBTreeView1.MC do begin

   FDConnection:=DBConnection.FDConnection;

   DBName:='coffeetest_db';
   DBTable:='dbtreeexplorertesttable';


   with DBFields do begin

    id:='id';
    idParent:='idParent';
    name:='name';
    sortIndex:='sortIndex';
    isFolder:='isFolder';
    isTrash:='isTrash';
    isChecked:='isChecked';
    external_id:='external_id';

   end;

   IsUseExternalID:=true;
   external_id_value:=1;

   PSDBTreeView1.MC.CopyCutPaste.OnCopyCut:=OnCopyCut;
   PSDBTreeView1.MC.MF.OnFocus:=OnFocusDBTreeView;

   InitialSetup;

end;




with PSDBTreeView2.MC do begin

   FDConnection:=DBConnection.FDConnection;

   DBName:='coffeetest_db';
   DBTable:='dbtreeexplorertesttable';


   with DBFields do begin

    id:='id';
    idParent:='idParent';
    name:='name';
    sortIndex:='sortIndex';
    isFolder:='isFolder';
    isTrash:='isTrash';
    isChecked:='isChecked';
    external_id:='external_id';

   end;

   PSDBTreeView2.MC.CopyCutPaste.OnCopyCut:=OnCopyCut;
   PSDBTreeView2.MC.MF.OnFocus:=OnFocusDBTreeView;

   IsUseExternalID:=true;
   external_id_value:=2;

   InitialSetup;

end;



end;

procedure TForm1.FormDestroy(Sender: TObject);
begin

PSDBTreeView1.MC.ClearAllPointers;
//PSDBTreeView1.MC.Checkboxes.UncheckAllChecked;
PSDBTreeView2.MC.ClearAllPointers;
//PSDBTreeView2.MC.Checkboxes.UncheckAllChecked;

end;

procedure TForm1.OnCopyCut(AIDSelectedArray: Tarray<integer>);
begin
FidSelectedArray:=AIDSelectedArray;
end;

procedure TForm1.OnExternalInsertSelect(AIDListInserted: Tarray<integer>);
begin
//
end;

procedure TForm1.OnFocusDBTreeView(Sender: TObject);
begin
if (Sender is TPSDBTreeView) then
 begin
// ShowMessage( (Sender as TPSDBTreeView).Name );
 FCurrentDBTreeView:=(Sender as TPSDBTreeView);
 end;

end;

procedure TForm1.PageControlChange(Sender: TObject);
begin

case PageControl.ActivePageIndex of

0: FCurrentDBTreeView:=PSDBTreeView1;
1: FCurrentDBTreeView:=PSDBTreeView2;

end;

end;

end.
